"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var _ = require("lodash");
var AsyncComponentComponent = (function () {
    function AsyncComponentComponent() {
        this.selectItem = new core_1.EventEmitter();
    }
    Object.defineProperty(AsyncComponentComponent.prototype, "source", {
        get: function () {
            return this._source;
        },
        set: function (v) {
            var temp = [];
            if (v) {
                temp = _.cloneDeep(v);
                for (var i = 0; i < temp.length; i++) {
                    temp[i]['index'] = i;
                }
            }
            this._source = temp;
        },
        enumerable: true,
        configurable: true
    });
    AsyncComponentComponent.prototype.ngOnInit = function () {
    };
    AsyncComponentComponent.prototype.hideDrop = function () {
        var _this = this;
        if (this.hideTimer) {
            clearTimeout(this.hideTimer);
            this.hideTimer = null;
        }
        this.hideTimer = setTimeout(function () {
            _this.showContainer = false;
        }, 100);
    };
    AsyncComponentComponent.prototype.focus = function () {
        this.changeText();
        // this.showContainer = true;
    };
    AsyncComponentComponent.prototype.onDocumentClick = function (ev) {
        this.hideDrop();
    };
    AsyncComponentComponent.prototype.selectText = function (ev, item) {
        ev.stopPropagation();
        if (this.hideTimer) {
            clearTimeout(this.hideTimer);
            this.hideTimer = null;
        }
        this.text = item.title;
        this.selectItem.emit(item);
        this.hideDrop();
    };
    AsyncComponentComponent.prototype.changeText = function () {
        var _this = this;
        if (this.asyncTimer) {
            clearTimeout(this.asyncTimer);
            this.asyncTimer = null;
        }
        this.source = [];
        this.asyncTimer = setTimeout(function () {
            var filterPromise = _this.options.asyncFilter(_this.text);
            filterPromise.then(function (res) {
                _this.source = _.cloneDeep(res || []);
                _this.showContainer = true;
            }).catch(function (e) {
                _this.source = [];
                _this.showContainer = true;
            });
        }, (this.options && this.options.asyncSpace) || 300);
    };
    AsyncComponentComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'dc-async-component',
                    template: "\n    <div class=\"display-flex width-100 flex-direction-column\" [style.position]=\"'relative'\" [style.max-width]=\"width\">\n      <input type=\"text\" [(ngModel)]=\"text\" (click)=\"$event.stopPropagation()\" (ngModelChange)=\"changeText()\" (focus)=\"focus()\">\n      <div class=\"complete-container width-100 flex-direction-column\" *ngIf=\"showContainer\">\n        <div *ngFor=\"let c of source\" class=\"source-title\" (click)=\"selectText($event, c)\"\n             [title]=\"c.title\">\n          {{c.title}}\n        </div>\n        <div *ngIf=\"!source || source.length == 0\"\n             style=\"display: flex;align-items: center;justify-content: center; padding: 10px 0;\">\n          No Data.\n        </div>\n      </div>\n    </div>\n  ",
                    styles: ["\n    .title.active {\n      color: red\n    }\n\n    input[type=text] {\n      border: solid 1px #ccc;\n      height: 30px;\n      line-height: 18px;\n    }\n\n    input[type=text]:hover, input[type=text]:focus {\n      border-color: #0081cc;\n    }\n\n    .title {\n      cursor: pointer;\n    }\n\n    .complete-container {\n      position: absolute;\n      top: 28px;\n      border: solid 1px #ccc;\n      background-color: #ffffff;\n      box-shadow: 0px 0px 5px 2px rgba(0, 0, 0, .2);\n      z-index: 1100;\n      max-height: 200px;\n      overflow: auto;\n    }\n\n    .source-title {\n      max-width: 100%;\n      height: 30px;\n      overflow: hidden;\n      text-overflow: ellipsis;\n      white-space: nowrap;\n      cursor: pointer;\n    }\n\n    .source-title:hover {\n      background-color: #edf0f5;\n    }\n\n    .source-title.selected {\n      background-color: #0081cc;\n      color: #ffffff;\n    }\n\n    .source-title.source-title.active {\n      color: rebeccapurple;\n    }\n  "]
                },] },
    ];
    /** @nocollapse */
    AsyncComponentComponent.ctorParameters = function () { return []; };
    AsyncComponentComponent.propDecorators = {
        "text": [{ type: core_1.Input },],
        "options": [{ type: core_1.Input },],
        "width": [{ type: core_1.Input },],
        "source": [{ type: core_1.Input },],
        "selectItem": [{ type: core_1.Output },],
        "onDocumentClick": [{ type: core_1.HostListener, args: ['document:click', ['$event'],] },],
    };
    return AsyncComponentComponent;
}());
exports.AsyncComponentComponent = AsyncComponentComponent;
//# sourceMappingURL=async.component.component.js.map